import 'package:nui_auth/web/nui_auth_web_json.dart';
import 'package:nui_core/data/nui_ent.dart';

class NUIAuthChangePasswordReq extends NUIEnt<NUIAuthChangePasswordReq>{
  NUIAuthChangePasswordReq.empty();
  NUIAuthChangePasswordReq({this.oldPassword, this.newPassword, this.confirmPassword});
  String oldPassword;
  String newPassword;
  String confirmPassword;

  @override
  NUIEntMapper<NUIAuthChangePasswordReq> mapper() => NUIAuthChangePasswordReqEnt();
}
class NUIAuthChangePasswordReqEnt extends NUIEntMapper<NUIAuthChangePasswordReq>{
  @override
  String entityName() => "NUIAuthChangePasswordReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthChangePasswordReq>(name: "oldPassword", type: NUIEntType.STRING, setter: (data, value) => data.oldPassword = value, getter: (data) => data.oldPassword),
    NUIEntField<NUIAuthChangePasswordReq>(name: "newPassword", type: NUIEntType.STRING, setter: (data, value) => data.newPassword = value, getter: (data) => data.newPassword),
    NUIEntField<NUIAuthChangePasswordReq>(name: "confirmPassword", type: NUIEntType.STRING, setter: (data, value) => data.confirmPassword = value, getter: (data) => data.confirmPassword),
  ];

  @override
  NUIAuthChangePasswordReq newInstance() => NUIAuthChangePasswordReq.empty();
}

class NUIAuthForgotPasswordReq extends NUIEnt<NUIAuthForgotPasswordReq>{
  NUIAuthForgotPasswordReq.empty();
  NUIAuthForgotPasswordReq({this.email});
  String email;

  @override
  NUIEntMapper<NUIAuthForgotPasswordReq> mapper() => NUIAuthForgotPasswordReqEnt();
}
class NUIAuthForgotPasswordReqEnt extends NUIEntMapper<NUIAuthForgotPasswordReq>{
  @override
  String entityName() => "NUIAuthForgotPasswordReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthForgotPasswordReq>(name: "email", type: NUIEntType.STRING, setter: (data, value) => data.email = value, getter: (data) => data.email),
  ];

  @override
  NUIAuthForgotPasswordReq newInstance() => NUIAuthForgotPasswordReq.empty();
}

class NUIAuthLoginReq extends NUIEnt<NUIAuthLoginReq>{
  NUIAuthLoginReq.empty();
  NUIAuthLoginReq({this.username, this.password, this.refreshToken, this.grantType});
  String username;
  String password;
  String grantType;
  String refreshToken;

  @override
  NUIEntMapper<NUIAuthLoginReq> mapper() => NUIAuthLoginReqEnt();
}
class NUIAuthLoginReqEnt extends NUIEntMapper<NUIAuthLoginReq>{
  @override
  String entityName() => "NUIAuthLoginReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthLoginReq>(name: "username", type: NUIEntType.STRING, setter: (data, value) => data.username = value, getter: (data) => data.username),
    NUIEntField<NUIAuthLoginReq>(name: "password", type: NUIEntType.STRING, setter: (data, value) => data.password = value, getter: (data) => data.password),
    NUIEntField<NUIAuthLoginReq>(name: "grantType", type: NUIEntType.STRING, setter: (data, value) => data.grantType = value, getter: (data) => data.grantType),
    NUIEntField<NUIAuthLoginReq>(name: "refreshToken", type: NUIEntType.STRING, setter: (data, value) => data.refreshToken = value, getter: (data) => data.refreshToken),
  ];

  @override
  NUIAuthLoginReq newInstance() => NUIAuthLoginReq.empty();
}

class NUIAuthLogoutReq extends NUIEnt<NUIAuthLogoutReq>{
  NUIAuthLogoutReq.empty();
  NUIAuthLogoutReq({this.accessToken});
  String accessToken;

  @override
  NUIEntMapper<NUIAuthLogoutReq> mapper() => NUIAuthLogoutReqEnt();
}
class NUIAuthLogoutReqEnt extends NUIEntMapper<NUIAuthLogoutReq>{
  @override
  String entityName() => "NUIAuthLogoutReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthLogoutReq>(name: "accessToken", type: NUIEntType.STRING, setter: (data, value) => data.accessToken = value, getter: (data) => data.accessToken),
  ];

  @override
  NUIAuthLogoutReq newInstance() => NUIAuthLogoutReq.empty();
}

class NUIAuthRenewTokenReq extends NUIEnt<NUIAuthRenewTokenReq>{
  NUIAuthRenewTokenReq.empty();
  NUIAuthRenewTokenReq({this.accessToken, this.refreshToken, this.grantType});
  String accessToken;
  String grantType;
  String refreshToken;

  @override
  NUIEntMapper<NUIAuthRenewTokenReq> mapper() => NUIAuthRenewTokenReqEnt();
}
class NUIAuthRenewTokenReqEnt extends NUIEntMapper<NUIAuthRenewTokenReq>{
  @override
  String entityName() => "NUIAuthRenewTokenReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthRenewTokenReq>(name: "accessToken", type: NUIEntType.STRING, setter: (data, value) => data.accessToken = value, getter: (data) => data.accessToken),
    NUIEntField<NUIAuthRenewTokenReq>(name: "grantType", type: NUIEntType.STRING, setter: (data, value) => data.grantType = value, getter: (data) => data.grantType),
    NUIEntField<NUIAuthRenewTokenReq>(name: "refreshToken", type: NUIEntType.STRING, setter: (data, value) => data.refreshToken = value, getter: (data) => data.refreshToken),
  ];

  @override
  NUIAuthRenewTokenReq newInstance() => NUIAuthRenewTokenReq.empty();
}

class NUIAuthSignUpReq extends NUIEnt<NUIAuthSignUpReq>{
  NUIAuthSignUpReq.empty();
  NUIAuthSignUpReq({this.username, this.password, this.email});
  String username;
  String password;
  String email;

  @override
  NUIEntMapper<NUIAuthSignUpReq> mapper() => NUIAuthSignUpReqEnt();
}
class NUIAuthSignUpReqEnt extends NUIEntMapper<NUIAuthSignUpReq>{
  @override
  String entityName() => "NUIAuthSignUpReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthSignUpReq>(name: "username", type: NUIEntType.STRING, setter: (data, value) => data.username = value, getter: (data) => data.username),
    NUIEntField<NUIAuthSignUpReq>(name: "password", type: NUIEntType.STRING, setter: (data, value) => data.password = value, getter: (data) => data.password),
    NUIEntField<NUIAuthSignUpReq>(name: "email", type: NUIEntType.STRING, setter: (data, value) => data.email = value, getter: (data) => data.email),
  ];

  @override
  NUIAuthSignUpReq newInstance() => NUIAuthSignUpReq.empty();
}

class NUIAuthSSOSignUpReq extends NUIEnt<NUIAuthSSOSignUpReq>{
  static const String SSO_TYPE_FACEBOOK = "fb";
  static const String SSO_TYPE_GOOGLE = "google";
  static const String SSO_TYPE_APPLE = "apple";

  NUIAuthSSOSignUpReq.empty();
  NUIAuthSSOSignUpReq({this.provider, this.providerToken, this.email});
  String provider;
  String providerToken;
  String email;

  @override
  NUIEntMapper<NUIAuthSSOSignUpReq> mapper() => NUIAuthSSOSignUpReqEnt();
}
class NUIAuthSSOSignUpReqEnt extends NUIEntMapper<NUIAuthSSOSignUpReq>{
  @override
  String entityName() => "NUIAuthSSOSignUpReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthSSOSignUpReq>(name: "provider", type: NUIEntType.STRING, setter: (data, value) => data.provider = value, getter: (data) => data.provider),
    NUIEntField<NUIAuthSSOSignUpReq>(name: "providerToken", type: NUIEntType.STRING, setter: (data, value) => data.providerToken = value, getter: (data) => data.providerToken),
    NUIEntField<NUIAuthSSOSignUpReq>(name: "email", type: NUIEntType.STRING, setter: (data, value) => data.email = value, getter: (data) => data.email),
  ];

  @override
  NUIAuthSSOSignUpReq newInstance() => NUIAuthSSOSignUpReq.empty();
}

class NUIAuthVerifyEmailReq extends NUIEnt<NUIAuthVerifyEmailReq>{
  NUIAuthVerifyEmailReq.empty();
  NUIAuthVerifyEmailReq({this.code, this.token});
  String code;
  String token;

  @override
  NUIEntMapper<NUIAuthVerifyEmailReq> mapper() => NUIAuthVerifyEmailReqEnt();
}
class NUIAuthVerifyEmailReqEnt extends NUIEntMapper<NUIAuthVerifyEmailReq>{
  @override
  String entityName() => "NUIAuthVerifyEmailReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthVerifyEmailReq>(name: "code", type: NUIEntType.STRING, setter: (data, value) => data.code = value, getter: (data) => data.code),
    NUIEntField<NUIAuthVerifyEmailReq>(name: "token", type: NUIEntType.STRING, setter: (data, value) => data.token = value, getter: (data) => data.token),
  ];

  @override
  NUIAuthVerifyEmailReq newInstance() => NUIAuthVerifyEmailReq.empty();
}

abstract class NUIBaseTokenResp{
  String accessToken;
  String refreshToken;
  int expiresIn;
  String tokenType;
}

class NUIAuthLoginResp extends NUIEnt<NUIAuthLoginResp> with NUIBaseTokenResp{
  NUIAuthLoginResp.empty();
  NUIAuthLoginResp({String accessToken, String refreshToken, int expiresIn, String tokenType}){
    this.accessToken = accessToken;
    this.refreshToken = refreshToken;
    this.expiresIn = expiresIn;
    this.tokenType = tokenType;
  }
  @override
  NUIEntMapper<NUIAuthLoginResp> mapper() => NUIAuthLoginRespEnt();
}
class NUIAuthLoginRespEnt extends NUIEntMapper<NUIAuthLoginResp>{
  @override
  String entityName() => "NUIAuthLoginResp";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthLoginResp>(name: "accessToken", type: NUIEntType.STRING, setter: (data, value) => data.accessToken = value, getter: (data) => data.accessToken),
    NUIEntField<NUIAuthLoginResp>(name: "refreshToken", type: NUIEntType.STRING, setter: (data, value) => data.refreshToken = value, getter: (data) => data.refreshToken),
    NUIEntField<NUIAuthLoginResp>(name: "expiresIn", type: NUIEntType.INTEGER, setter: (data, value) => data.expiresIn = value, getter: (data) => data.expiresIn),
    NUIEntField<NUIAuthLoginResp>(name: "tokenType", type: NUIEntType.STRING, setter: (data, value) => data.tokenType = value, getter: (data) => data.tokenType),
  ];

  @override
  NUIAuthLoginResp newInstance() => NUIAuthLoginResp.empty();
}



class NUIAuthRenewTokenResp extends NUIEnt<NUIAuthRenewTokenResp> with NUIBaseTokenResp{
  NUIAuthRenewTokenResp.empty();
  NUIAuthRenewTokenResp({String accessToken, String refreshToken, int expiresIn, String tokenType}){
    this.accessToken = accessToken;
    this.refreshToken = refreshToken;
    this.expiresIn = expiresIn;
    this.tokenType = tokenType;
  }

  @override
  NUIEntMapper<NUIAuthRenewTokenResp> mapper() => NUIAuthRenewTokenRespEnt();
}
class NUIAuthRenewTokenRespEnt extends NUIEntMapper<NUIAuthRenewTokenResp>{
  @override
  String entityName() => "NUIAuthRenewTokenResp";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthRenewTokenResp>(name: "accessToken", type: NUIEntType.STRING, setter: (data, value) => data.accessToken = value, getter: (data) => data.accessToken),
    NUIEntField<NUIAuthRenewTokenResp>(name: "refreshToken", type: NUIEntType.STRING, setter: (data, value) => data.refreshToken = value, getter: (data) => data.refreshToken),
    NUIEntField<NUIAuthRenewTokenResp>(name: "expiresIn", type: NUIEntType.INTEGER, setter: (data, value) => data.expiresIn = value, getter: (data) => data.expiresIn),
    NUIEntField<NUIAuthRenewTokenResp>(name: "tokenType", type: NUIEntType.STRING, setter: (data, value) => data.tokenType = value, getter: (data) => data.tokenType),
  ];

  @override
  NUIAuthRenewTokenResp newInstance() => NUIAuthRenewTokenResp.empty();
}